#include "Engine.h"

Engine::Engine():
    running(true)
{
    srand(0);
    TCODConsole::setCustomFont("Alloy_curses_12x12.bmp", TCOD_FONT_LAYOUT_ASCII_INROW, 16, 16);
    TCODConsole::initRoot(80, 50, "Dark Isolation", false); //false: not fullscreens

   // TCODConsole::root->setForegroundColor(TCODColor::black);
    //TCODConsole::root->setBackgroundColor(TCODColor::TCODColor(5, 5, 5));
    //TCODConsole::credits();
    state = MENU;
    game=NULL;

    TCODConsole::setColorControl(TCOD_COLCTRL_1,TCODColor::red,TCODColor::black);
    TCODConsole::setColorControl(TCOD_COLCTRL_2,TCODColor::yellow,TCODColor::black);
    TCODConsole::setColorControl(TCOD_COLCTRL_3,TCODColor::green,TCODColor::black);
    TCODConsole::setColorControl(TCOD_COLCTRL_4,TCODColor::blue,TCODColor::black);
    TCODConsole::setColorControl(TCOD_COLCTRL_5,TCODColor::orange,TCODColor::black);
}

Engine::~Engine()
{
    //dtor
}
void Engine::drawMenu()
{
    TCODConsole::root->printCenter(40,25,TCOD_BKGND_NONE,"Press any key to begin.");
}
void Engine::handleMenuInput()
{
    TCOD_key_t key=TCODConsole::waitForKeypress(true);

    switch(key.vk)
    {
        case TCODK_ESCAPE:
            running = false;
            break;
        default:
            state = GAME;
            TCODConsole::root->clear();
            break;
    }
}

void Engine::run()
{
    while ( running && ! TCODConsole::isWindowClosed() )
    {
        switch(state)
        {
            case MENU:
                drawMenu();
                TCODConsole::flush(); //finally, render
                handleMenuInput();
                break;
            case GAME:
                if(game==NULL)
                    game = new Game();
                game->draw();
                TCODConsole::flush();
                if(!game->handleInput()) //return false if trying to EXIT
                {
                    delete game;
                    game = NULL;
                    state = MENU;
                }
                break;
        }
    }
}
