#include "Entity.h"

unsigned int Entity::CURR_ID = 0;

Entity::Entity(EventManager& eventManager, Level* level, int x, int y, bool blocking):
    eventManager(eventManager),
    level(level),
    x(x),
    y(y),
    c(1),
    blocking(blocking),
    die(false)
{
    id = CURR_ID++;
}

Entity::~Entity()
{
    if(x>0 && y>0)
        level->tiles[y][x].remove(id);
}

void Entity::attack(Entity* e)
{

}
bool Entity::move(int tx, int ty)
{
    if(level->isEmpty(tx, ty))
    {
        Entity* toAttack = level->hasBlockingEntity(tx, ty);
        if( toAttack != NULL )
        {
            attack(toAttack);
        }
        else
        {
            moveTo(tx, ty);
        }
        return true;
    }
    return false;
}
bool Entity::move(int direction)
{
    int tx=x;
    int ty=y;

    switch(direction)
    {
        case LEFT:
            tx--;
            break;
        case RIGHT:
            tx++;
            break;
        case UP:
            ty--;
            break;
        case DOWN:
            ty++;
            break;
        case UP_LEFT:
            tx--;
            ty--;
            break;
        case UP_RIGHT:
            tx++;
            ty--;
            break;
        case DOWN_LEFT:
            tx--;
            ty++;
            break;
        case DOWN_RIGHT:
            tx++;
            ty++;
            break;
        default:
            printf("Entity::move(...) - Invalid direction specified!\n");
            return false;
            break;
    }
    if(level->isEmpty(tx, ty))
    {
        Entity* toAttack = level->hasBlockingEntity(tx, ty);
        if( toAttack != NULL )
        {
            attack(toAttack);
        }
        else
        {
            moveTo(tx, ty);
        }
        return true;
    }
    return false;
}

void Entity::moveTo(int tx, int ty)
{
    level->tiles[y][x].remove(id);
    x = tx;
    y = ty;
    level->tiles[y][x].add(this);
}

void Entity::removeFromMap()
{
    level->tiles[y][x].remove(id);
    x = -1;
    y = -1;
}
void Entity::death()
{

}
void Entity::step()
{
    //do nothing
}
