#ifndef ENTITY_H
#define ENTITY_H

#include "common.h"
#include "Level.h"
#include "EventManager.h"

class Entity
{
    public:
        enum directions
        {
            LEFT,
            RIGHT,
            UP,
            DOWN,
            UP_LEFT,
            UP_RIGHT,
            DOWN_LEFT,
            DOWN_RIGHT,

            NUM_DIRECTIONS
        };
        static unsigned int CURR_ID;
        enum entity_types
        {

        };
        unsigned int entityType;
    protected:
        EventManager& eventManager;
        Level* level;
    public:
        TCODColor::TCODColor fg;
        unsigned int id;
        int x;
        int y;
        char c;
        bool friendly;
        bool blocking; //Monsters, players, etc. are blocking. Items are not, you can walk over them.
        bool die;
        Entity(EventManager& eventManager, Level* level, int x, int y, bool blocking = true);
        virtual ~Entity();
        virtual void death();
        virtual void step();
        virtual void attack(Entity* e);
        void removeFromMap();
        void moveTo(int tx, int ty);
        bool move(int direction);
        bool move(int tx, int ty);
};

#endif // ENTITY_H
