#ifndef GAME_H
#define GAME_H

#include "common.h"
#include "Level.h"
#include "Player.h"
#include "Entity.h"
#include "NPC.h"

class Game
{
    private:
        int stage;
        int frame;
        int kills;
        map<unsigned int, Entity*> entities;
        Player* player;
        Level* level;
        EventManager eventManager;
        void addEntity(Entity* e);

        TCODConsole* inventoryScreen;
        enum states
        {
            NONE,
            INVENTORY,
            DROP_ITEM,
            GAME_OVER,
            FADE_OUT,
            CREDITS,
            DEAD
        };

        int state;
    public:
        Game();
        virtual ~Game();
        void drawHUD();
        void draw();
        void step();
        bool handleInput();
};

#endif // GAME_H
