#ifndef ITEM_H
#define ITEM_H

#include "common.h"
#include "Entity.h"

class Player;

class Item : public Entity
{
    private:
        void setName(int type);
    public:
        enum item_types
        {
            CORPSES_START,
                BAT_CORPSE,
                RAT_CORPSE,
                BEAR_CORPSE,
                KITTEN_CORPSE,
                SNAKE_CORPSE,
            CORPSES_END,

            CRAFTABLE_START,
                BAT_PELT,
                SNAKE_SKIN,
                BEAR_PELT,
                STONE,
                STICK,
            CRAFTABLE_END,

            EATABLE_START,
                BAT_MEAT,
                RAT_MEAT,
                SNAKE_MEAT,
                KITTEN_MEAT,
                BEAR_MEAT,
                MYSTERY_MEAT,
            EATABLE_END,

            EQUIPABLE_START,
                HEAD_START,
                    BAT_PELT_HAT,
                    RAT_PELT_HAT,
                    BEAR_PELT_HAT,
                HEAD_END,
                CHEST_START,
                    BAT_PELT_SHIRT,
                    RAT_PELT_SHIRT,
                    BEAR_PELT_SHIRT,
                CHEST_END,
                LEGS_START,
                    BAT_PELT_PANTS,
                    RAT_PELT_PANTS,
                    BEAR_PELT_PANTS,
                LEGS_END,
                WEAPONS_START,
                    STONE_DAGGER,
                    STONE_SPEAR,
                    BEAR_CLAW,
                WEAPONS_END,
            EQUIPABLE_END,
            NOTE
        };
        enum equip_slot
        {
            WEAPON,
            HEAD,
            CHEST,
            LEGS,

            NUM_EQUIP_SLOTS
        };
        string name;
        bool eatable;
        bool butcherable;
        bool craftable;
        bool equipped;
        int type;
        int equipSlot;

        int effect;

        Item(EventManager& eventManager, Level* level, int x, int y, int type);
        ~Item();

        void butcher(Player* player);
        void craft(Player* player);
        int eat();

};

#endif // ITEM_H
