#ifndef LEVEL_H
#define LEVEL_H

#include "common.h"
#include "Tile.h"


class Level
{
    public:
        TCODMap::TCODMap* lightMap;
    private:
        TCODBsp* bsp;
        void recurse(TCODBsp* node);

    public:
        map<unsigned int, Entity*>& entities;

        vector<Entity*> visibleEntities;
        int w;
        int h;

        Tile** tiles;
        Level(map<unsigned int, Entity*>& entities, int w, int h);
        ~Level();
        void addEntity(Entity* e);
        void setType(int x, int y, char type);
        void draw();
        void generate();
        //x, y, radius
        void calculateFOV(int x, int y, int r);
        bool isEmpty(int x, int y);
        Entity* hasBlockingEntity(int x, int y);
        bool isVisible(int x, int y);
        float distance(int ax, int ay, int bx, int by);
};

#endif // LEVEL_H
