#ifndef NPC_H
#define NPC_H

#include "common.h"
#include "Entity.h"
#include "Item.h"

class NPC : public Entity
{
    private:
        static const int TURN_TIME = 10;
    public:
        enum npc_type
        {
            PLAYER,
            FRIEND,
            BAT,
            SNAKE,
            WOLF,
            BEAR,
            KITTEN,

        };
        char type;
        Entity* target;
        string name;
        int armor;
        int weaponAtk;
        bool isPlayer;
        bool aggressive;
        bool agro; //currently attacking / engaging player
        int agroTimer; //if no attacks for 10 turns, agro turns off
        bool fleeing;
        int fleeTimer; //flee only for 10 turns. then turn off fleetimer
        bool wounded;
        int agroRadius;
        int maxHealth;
        int health;
        int fleeThreshold;
        int speed;
        int woundedThreshold;
        int turn; //each player turn, npc turn is increase by 'speed'.
                    //if this value reaches 10, the npc takes a turn. 1 = slowest. >10 = faster than player
        int minDmg;
        int dmgRange;
        int hit;   // number out of 10. 0 = full misses, 10 = full accuracy
        NPC(EventManager& eventManager, Level* level, int x, int y, char type = 0);
        ~NPC();
        void action();
        virtual void death();
        virtual void attack(Entity* e);
        virtual void step();
};

#endif // NPC_H
