#ifndef PLAYER_H
#define PLAYER_H

#include "common.h"
#include "NPC.h"
#include "Item.h"

class Player : public NPC
{
    public:
        vector<Item*> items;
        Item** equipment;

        static const int HUNGER_HUNGRY = 50;
        static const int HUNGER_VERY_HUNGRY = 100;
        static const int HUNGER_NEAR_STARVING = 150;
        static const int HUNGER_STARVING=200;
        static const int HUNGER_DEATH=250;

        static const int REGEN_STEP = 5; //regen 1 hp every X steps
        int hunger;
        int thirst;
        int stepCounter;

        Player(EventManager& eventManager, Level* level, int x, int y);
        virtual ~Player();

        virtual void step();
        Item* useItem(unsigned int index);
        void dropItem(unsigned int index);
        bool grab();
 };

#endif // PLAYER_H
