#ifndef TILE_H
#define TILE_H

#include "common.h"

class Entity;

class Tile
{
    public:
        enum tile_types
        {
            GROUND,
            WALL,
            WATER,
            WATER_SHALLOW,
            NUM_TILE_TYPES
        };
        char type;
        int ascii;
        bool explored;
        TCODColor::TCODColor fg;
        TCODColor::TCODColor bg;
        list<Entity*> entities;

        void setType(char t);

        bool remove(unsigned int id);
        void add(Entity* e);
        Entity* hasBlockingEntity();
        Entity* drawEntity();
        Tile();
        virtual ~Tile();
};

#endif // TILE_H
